//-------------------------------------------------------------------
//	File:		   counter.c
//	Comments:   by George Ziniewicz
//-------------------------------------------------------------------

//#include <math.h>
//#include <stdlib.h>

#include "utility.h"
#include "counter.h"

//--------------------------------------------------------------------------------------
Counter::Counter() {
	ncounter=0;
	toggleRate=2;
	newRate=.1;
	damp=1;
};

Counter::~Counter() {};

//--------------------------------------------------------------------------------------

void Counter::init(int n) {
	int i;
	
	if (n>maxcounters) ncounter=maxcounters;
	else               ncounter=n;
	for (i=0; i<ncounter; i++) {
		counter[i]=rndn(360);
		    max[i]=rndn(.02)+.02;
		    inc[i]=max[i];
		     on[i]=1;
	     fixed[i]=0;
	}
	return;
}

//-------------------------------------------------------------------------------------


// return sin value of counter "i" at "speed" scaled from "offset" to "offset" + "range"

float Counter::get(int n, float speed, float scale, float offset) {  
   return (sin(counter[n]*speed)*.5+.5)*scale+offset;
}

//--------------------------------------------------------------------------------------

float Counter::get2(int n, float speed, float roll, float scale, float offset) {  
   return (sin(counter[n]*speed+roll)*.5+.5)*scale+offset;
}

//--------------------------------------------------------------------------------------

void Counter::update(float fDeltaTime, float speed) {
	float range;
	int i;
   
	for (i=0; i<ncounter; i++) {
		if (!fixed[i]) {
			if (rndn(1)<toggleRate*fDeltaTime) on[i]=(rndn(1)<.33)? 0:1; // rnd toggle clutch
			if (rndn(1)< newRate*fDeltaTime) { // rnd make new max counter movement
				range=rndn(.02)+.02;
				max[i]=(rndn(1)<.45) ? range:-range; // rnd chg ramp + or - unbalanced
			}
			if (on[i]) inc[i]=(max[i]-inc[i])*   damp*fDeltaTime+inc[i]; // ramp up
			else       inc[i]=        inc[i] *(1-damp*fDeltaTime);       // slow down
		}
		counter[i]+=(inc[i]*fDeltaTime*speed);  // move counter
	}
	return;
}

//----------------------------------------------------------------------------------


