#if !defined(dialog_h)
#define      dialog_h

#include "main.h"
#include "text.h"
#include "Texture.h"

//---------------------------------------------------------------------------------

class Widget{
public:     Widget();
	virtual ~Widget();

	static int textSize;
	static Texture *tex;
	static Text *text;

	char label[80];
	int ID, index, type, on, size;
	float x,y, width,height, x2,y2;

	virtual void init(char *s, int inID, int inindex, int intype,
		     float inx, float iny, float inwidth, float inheight,
			  float invalue=0, float inmin=0, float inmax=0, int flag=0, int inlinear=0);
	int inside(int mousex,int mousey, int ox,int oy);
	virtual int process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current);
	virtual void show(float ox,float oy, int current);
};

//---------------------------------------------------------------------------------

class Slider:public Widget{
public:      Slider();
	virtual ~Slider();

	float min,max,range,value;
	int truncate, linear;
	static float texX0,texX1, texY0,texY1;

	virtual void init(char *s, int inID, int inindex, int intype,
		     float inx, float iny, float inwidth, float inheight,
			  float invalue, float inmin, float inmax, int flag, int inlinear);
	virtual void show(float ox,float oy, int current);
	virtual int process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current);
};

//---------------------------------------------------------------------------------

class Toggle:public Widget{
public:      Toggle();
	virtual ~Toggle();

	static float texX0,texX1, texY0,texY1;

	virtual void init(char *s, int inID, int inindex, int intype,
	        float inx, float iny, float inwidth, float inheight,
			  float invalue, float inmin, float inmax, int flag, int inlinear);
	virtual void show(float ox,float oy, int current);
	virtual int process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current);
};

//---------------------------------------------------------------------------------

class Button:public Widget{
public:      Button();
	virtual ~Button();

	static float texX0,texX1, texY0,texY1;

	virtual void init(char *s, int inID, int inindex, int intype,
		     float inx, float iny, float inwidth, float inheight,
			  float invalue, float inmin, float inmax, int flag, int inlinear);
	virtual void show(float ox,float oy, int current);
	virtual int process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current);
};

//---------------------------------------------------------------------------------

class Back:public Button{
public:     Back();
	virtual ~Back();

	static float texX0,texX1, texY0,texY1;

	virtual void init(char *s, int inID, int inindex, int intype,
		     float inx, float iny, float inwidth, float inheight,
			  float invalue, float inmin, float inmax, int flag, int inlinear);
	virtual void show(float ox,float oy, int current);
	virtual int process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current);
};

//---------------------------------------------------------------------------------

class Title:public Widget{
public:     Title();
	virtual ~Title();

	static float texX0,texX1, texY0,texY1;

	virtual void init(char *s, int inID, int inindex, int intype,
		     float inx, float iny, float inwidth, float inheight,
			  float invalue, float inmin, float inmax, int flag, int inlinear);
	virtual void show(float ox,float oy, int current);
	virtual int process(Key *key, Mouse *mouse, float ox, float oy, float *outValue, int current);
};

//---------------------------------------------------------------------------------

#define maxa 50
	enum widgetTypes {SLIDER,TOGGLE,BUTTON,BACK,TITLE};

	#define maxDialogDepth 19

class Dialog{
public:     Dialog();
	virtual ~Dialog();

	int ID, nitems, activeID, currentIndex, saveView;
	float activeValue, ox, oy;
	int dialogStack[maxDialogDepth], ndialogPushed;
	float fadedir, fade, inten;

	Widget *controls[maxa];
	Mouse *mouse;
	Key *key;
	Text *text;
	Time *time;

	void clear(void);
	int control(int type, char *label, int ID,
				   int x,int y, int width,int height,
				   float value=0, float min=0,float max=0, int truncate=0, int linear=0);

	void check(void);
	void show(void);
	void service(void);
	void init(int ID, int inpush);
	void push(void);
	void pop(void);
	void run(void);
};

void drawQ(Texture *tex, float x, float y, float x2, float y2,
		   float texX0,float texY0, float texX1,float texY1);


//---------------------------------------------------------------------------------------

#endif