#if !defined(game_h)
#define      game_h

#include "main.h"
#include "geom.h"
#include "mesh.h"
#include "object.h"
#include "particle.h"

//---------------------------------------------------------------------------------
 
class Pack:public Object{
public:		 Pack();
	virtual ~Pack();

	int nbullet;
};

//---------------------------------------------------------------------------------

class Character:public Object{
public:		 Character();
	virtual ~Character();

	int nlives, nbullet;
	float health;
};

//---------------------------------------------------------------------------------

class Game:public Object{
public:		 Game();
	virtual ~Game();

	Object splato, port, med;
	Texture *splat;
	Particle *mybullet, *hisbullet, *bloodp;
	Character him,me;
	Pack pack;
	Text *gen;
	Mesh *mesh;
	Geom *geom;
	Counter *app;
	Texture *waterTex;
	FSOUND_SAMPLE *myfire, *hisfire, *splash, *rico1,*rico2,
		           *chimes, *cosmic, *reload, *twing, *wind;

	float bulletSpeed, aggr, difficulty, mobility, hand, handHeight, waterHeight;
	float lastTauntTime, lastBulletTime;
	int   maxlives, maxbullet, teleportChannel;
	int   lastoption, lastimage, lastuniverse, lastb0,lastb1;

	void init(void);
	void boost(void);
	void update(int dialogs);
	void start(void);
	void annot(void);
	void idle_taunt(void);
	void beat_taunt(void);
	void end_taunt(void);
	void ouch(void);
	void draw_him(void);
	void draw(Object *object);
	void draw_gun(void);
	void draw_water(void);
	void draw_crosshair(void);
	int proc_teleport(void);
	int  fire_bullet(void);
	void new_level(void);
	void matmult(float *inx, float *iny, float *inz);
	void taunt(void);
};

//---------------------------------------------------------------------------------

#endif