//-------------------------------------------------------------------
//	File:		   geom.c
//	Comments:   by George Ziniewicz
//-------------------------------------------------------------------

#include "geom.h"


//--------------------------------------------------------------------------------------

Geom::Geom() {
	texmagx=1; texmagy=1;
	texoffx=0; texoffy=0;
	tx0=0; tx1=1; ty0=0; ty1=1;
};

Geom::~Geom() {};

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

void Geom::draw_pill(float size, float thick) {
	GLUquadric *q;
	q=gluNewQuadric();
	gluQuadricTexture(q,GL_TRUE);
	glPushMatrix();
		glTranslatef(0,0,-thick*.5);

		gluQuadricOrientation(q, GLU_OUTSIDE);
		gluCylinder(q,size,size,thick,30,3);

		gluQuadricOrientation(q, GLU_INSIDE);
		gluDisk(q,0,size,30,3);

		glTranslatef(0,0,thick);
		gluDisk(q,0,size,30,3);

	glPopMatrix();
	gluDeleteQuadric(q);
	return;
}

//---------------------------------------------------------------------------


void Geom::draw_quad(float inx0, float iny0, float inz0,
					 float inx1, float iny1, float inz1,
					 float inx2, float iny2, float inz2,
					 float inx3, float iny3, float inz3) {
	glBegin(GL_QUADS);
		glTexCoord2f(tx0        +texoffx,ty0        +texoffy); glVertex3f(inx0,iny0,inz0);
		glTexCoord2f(tx1*texmagx+texoffx,ty0        +texoffy); glVertex3f(inx1,iny1,inz1);
		glTexCoord2f(tx1*texmagx+texoffx,ty1*texmagy+texoffy); glVertex3f(inx2,iny2,inz2);
		glTexCoord2f(tx0        +texoffx,ty1*texmagy+texoffy); glVertex3f(inx3,iny3,inz3);
		glEnd();
	return;
}

//-----------------------------------------------------------

void Geom::draw_quad(void) {
	glBegin(GL_QUADS);
		glTexCoord2f(tx0        +texoffx,ty0        +texoffy); glVertex3f(x0,y0,z0);
		glTexCoord2f(tx1*texmagx+texoffx,ty0        +texoffy); glVertex3f(x1,y1,z1);
		glTexCoord2f(tx1*texmagx+texoffx,ty1*texmagy+texoffy); glVertex3f(x2,y2,z2);
		glTexCoord2f(tx0        +texoffx,ty1*texmagy+texoffy); glVertex3f(x3,y3,z3);
		glEnd();
	return;
}

//-----------------------------------------------------------


