// skybox.cpp

#include "skybox.h"
#include "utility.h"

//-------------------------------------------------------------------------------

Skybox::Skybox(){
	hw=0;
	canCull=0;
}

Skybox::~Skybox(){
}

//-------------------------------------------------------------------------------

void Skybox::init(void) {
	sb0.repeatMode=GL_CLAMP;
	sb1.repeatMode=GL_CLAMP;
	sb2.repeatMode=GL_CLAMP;
	sb3.repeatMode=GL_CLAMP;
	sbt.repeatMode=GL_CLAMP;
	sbb.repeatMode=GL_CLAMP;
	sb0.loadtex("ef.bmp", -1,0, 0);
	sb1.loadtex("er.bmp", -1,0, 0);
	sb2.loadtex("eb.bmp", -1,0, 0);
	sb3.loadtex("el.bmp", -1,0, 0);
	sbt.loadtex("et.bmp", -1,0, 0);
	sbb.loadtex("e0.bmp", -1,0, 0);
}

//-------------------------------------------------------------------------------

void Skybox::draw(float size) {
	int face;

	if (canCull) {
		face=(hw->camera->heading+45)/90; // cull behind panel
		if ((hw->camera->pitch<330)&&(hw->camera->pitch>30)) face=-1;
	}
	else face=-1;
	glColor3f(r,g,b);
	glDepthMask(GL_FALSE);
	glEnable(GL_TEXTURE_2D);
	if (face!=2) {
		glPushMatrix();
			glTranslatef(0,0,-size);
			draw1(&sb0,size);
			glPopMatrix();
	}
	if (face!=3) {
		glPushMatrix();
			glTranslatef(size,0,0);
			glRotatef(270,0,1,0);
			draw1(&sb1,size);
			glPopMatrix();
	}
	if (face!=0) {
		glPushMatrix();
			glTranslatef(0,0,size);
			glRotatef(180,0,1,0);
			draw1(&sb2,size);
			glPopMatrix();
	}
	if (face!=1) {
		glPushMatrix();
			glTranslatef(-size,0,0);
			glRotatef(90,0,1,0);
			draw1(&sb3,size);
			glPopMatrix();
	}
	glPushMatrix(); // top
		glTranslatef(0,size,0);
		glRotatef(90,1,0,0);
		draw1(&sbt,size);
		glPopMatrix();

	glPushMatrix(); // bottom
		glTranslatef(0,-size,0);
		glRotatef(-90,1,0,0);
		draw1(&sbb,size);
		glPopMatrix();
	glDepthMask(GL_TRUE);
	glDisable(GL_TEXTURE_2D);
	return;
}


//-------------------------------------------------------------------------------

void Skybox::draw1(Texture *tex, float size) {
	tex->bind();
	glBegin(GL_QUADS);
		glTexCoord2f(0,0); glVertex2f(-size,-size);
		glTexCoord2f(1,0); glVertex2f( size,-size);
		glTexCoord2f(1,1); glVertex2f( size, size);
		glTexCoord2f(0,1); glVertex2f(-size, size);
		glEnd();
	return;
}

//-------------------------------------------------------------------------------



