// global vars -------------------------------------------------------------

int help=0, infoOn=0, dialogs=0;// blending
float ex=0, worldSize;
int keystate, capture;

int   noctaves,introDone=0, windowID=0;
float persistence;
//char   s[80];

//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------

int main(int argc, char** argv){
	if (pref.load(titlestr)==0) {
		pref.pause=0;
		log_message("Loaded Prefs.");
	}
	else {
		log_message("No Prefs found.");
		init_pref();
		pref.fullscreen=1;
		pref.windowx=600;
		pref.windowy=600;
	}

	screen.width =glutGet(GLUT_SCREEN_WIDTH); // create window -----------
	screen.height=glutGet(GLUT_SCREEN_HEIGHT);

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	if (pref.fullscreen) glutInitWindowSize(screen.width,screen.height);
	else                 glutInitWindowSize(pref.windowx,pref.windowy);
	windowID=glutCreateWindow(titlestr);
	if (pref.fullscreen) glutFullScreen();

	glutDisplayFunc(display); // callbacks -------------------------------
	glutIdleFunc(idle);
	glutKeyboardFunc(keyboard);
	glutMotionFunc(motion);
	glutMouseFunc(mouseCB);
	glutPassiveMotionFunc(motion);
	glutReshapeFunc(reshape);
	glutSpecialFunc(specialdown);
	glutSpecialUpFunc(specialup);
	//glutKeyboardUpFunc(keyboardup0);

	appInit();
	log_message("Ready...\n");
	glutMainLoop();
	glutDestroyWindow(windowID);
	return 0;
}

//------------------------------------------------------------------------

void idle(void) {glutPostRedisplay();}

//------------------------------------------------------------------------

void display(void) {
	appRender();
	glutSwapBuffers();
}

//------------------------------------------------------------------------

void reshape(int w, int h){
	if (!pref.fullscreen) {
		pref.windowx=w;
		pref.windowy=h;
	}
	screen.width=w;
	screen.height=h;
	screen.set_letterbox(pref.letterbox);
	screen.set_viewport();
}

//------------------------------------------------------------------------

bool appInit(void) { // Called after window create and OpenGL init
	GLfloat fogcolor[4]={1,1,1,1};

	glEnable(GL_COLOR_MATERIAL); 
	glColorMaterial(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE);  
	glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);
	glMateriali(GL_FRONT_AND_BACK,GL_SHININESS,50);//5bigspot-50smallspot
   
	glShadeModel(GL_SMOOTH); 
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glAlphaFunc(GL_GREATER,0);
	glDisable(GL_DITHER);
	
	//fogcolor[0]=screen.r;
	//fogcolor[1]=screen.g;
	//fogcolor[2]=screen.b;
	glFogi( GL_FOG_MODE,GL_LINEAR);
	glFogfv(GL_FOG_COLOR,fogcolor);
	glFogf( GL_FOG_START,0.1);
	glFogf( GL_FOG_END,2);
	//glHint( GL_FOG_HINT,GL_NICEST);

	glEnable(GL_POINT_SMOOTH);

	screen.nearz=NEARZ;
	screen.farz=FARZ*pref.bracket;

	srand(time.msTime); // init app
	init_once();
	init_vars();

	glutSetCursor(GLUT_CURSOR_NONE);

	return true;
}

//-----------------------------------------------------------------------

void appShutdown() {
	log_message("\nShutting down...");
# if defined (hasstars)
	starfield.destroy();
#endif
	shutdown_this();
	return;
}

//---------------------------------------------------------------------------------------

bool appRender() {
	static double lastBlankTime, lastBlankOnTime;
	float aspect=(float)screen.width/screen.height;

	time.update(); // timing governor, seconds
	if (rndn(1)<.01) srand(time.msTime);

	if (!pref.pause) {
		cameraMove.update(time.fDeltaTime,pref.spd2);
		//lightRotate.update(time.fDeltaTime,pref.paren);
	}
	cameraRotate.update(time.fDeltaTime,pref.spd1);
	textEffect.update(time.fDeltaTime,1);

	clock.update();

	clock.x=screen.width-100;
	clock.y=screen.height-20;
	annot.y=screen.height-20;

	if (pref.fog) {// fog
		float v;
		if ((pref.b2+pref.brace)<(pref.brace)) v=        pref.brace;
		else                                   v=pref.b2+pref.brace;
		glFogf(GL_FOG_START,pref.brace+pref.b1);
		glFogf(GL_FOG_END,  pref.brace+pref.b2);//v
	}
	set_polymode(&pref);

	if (capture==3) capture=1;
	if (capture==1) {
		screen.width =256;
		screen.height=256;
		screen.needblank=1;
		render_frame(aspect);
		screen.width =glutGet(GLUT_SCREEN_WIDTH);
		screen.height=glutGet(GLUT_SCREEN_HEIGHT);

		end_shatter(0,&shatter, &screen, &time, &pref, &capture, &skip);

		glBindTexture(GL_TEXTURE_2D, shatter.texID);
		glCopyTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 0, 0, 256, 256);

		screen.needblank=1;
		capture=2;
	}
	if (capture==2) {
		camera.fov=90;
		screen.farz=FARZ*10;
	}
	else {
		camera.fov=pref.fov;
		screen.farz=FARZ*pref.bracket;
	}

	if (canBlank) {
		if ((time.fTime>(lastBlankTime+2))) { // randomly change blank state? // &&ortho
			if (rndn(1)<10*time.fDeltaTime) { // change % of the time to noblank
				if ((pref.blank)&&(time.fTime>(lastBlankOnTime+20))) {
					lastBlankOnTime=time.fTime;
					pref.blank=0;
				}
			}
			else if (!pref.blank) pref.blank=1;
			lastBlankTime=time.fTime;
		}
	}

	render_frame(aspect);

	if (help) do_title(); // refresh help screen
	if (pref.fclock) clock.draw();
	checkGL();

	if ((time.realTime>=beginTime-1)&& // beginning fadein
		(time.realTime<(beginTime+1))) {
		float f=1-fabs(time.realTime-beginTime);
		screen.fade(f);
	}
	else if (ex) { // exit fadeout
		//dialogs=0;
		//screen.color(0,0,0);
		if ((time.fTime-ex)>=3.5) {
			appShutdown();
			log_message("Destroying window...");
			glutDestroyWindow(windowID);
			log_message("Fin\n");
			exit(0);
		}
		screen.fade((time.fTime-ex)/3.5);
	}

	key.key=0;
	key.skey=0;
	//key.alt=0;
	//key.control=0;
	//key.shift=0;
	mouse.buttonstep();
	if (capture==1) capture=2;
	if (delayms) delay(delayms); // to check time-correction

	return true;
}

//---------------------------------------------------------------------------------------

void render_frame(float aspect) {
	if (pref.letterbox) {
		screen.set_letterbox(0);
		screen.set_viewport();
		screen.set_ortho();
		screen.set_letterbox(pref.letterbox);
		screen.mask();
		//set_polymode(&pref);
	}

	if ((screen.needblank==1)||(screen.needblank==2)) {
		glClearColor(0,0,0,1);
		glClear(GL_COLOR_BUFFER_BIT);
		glClearColor(screen.r,screen.g,screen.b,1);
		screen.needblank++;
	}
	if (screen.needblank==3) screen.needblank=0;

	screen.set_letterbox(pref.letterbox);
	screen.set_viewport();
	screen.set_ortho();

	if ((!pref.blank)&&(pref.c2<1)) {// screenfade f11/f12/<SPACE>
		screen.fade(pref.c2*time.fDeltaTime*40);
	}
	screen.clear();

//...............................................................

#if defined (ortho)
	screen.set_ortho();
#else
	screen.set_perspective(aspect);
	view_this();
#endif

	set_polymode(&pref);
	draw_this(); // main draw for this app

	screen.set_letterbox(0);
	screen.set_viewport();
	screen.set_ortho();
	annot_this();
	return;
}


//--utility -----------------------------------------------------------------------------
//---------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------

void keyboard(unsigned char inkey, int x, int y){
	screen.needblank=0;
	key.set(inkey); // load key and all modifiers
	switch(key.key){
	case 27: case 'q': case 'Q':
		if (ex) ex=time.fTime-5;
		else {
			ex=time.fTime; 
			capture=1;
			help=0;
			pref.blank=0; pref.c2=0;
		}
			break;

		case '-': pref.spd1*=0.9;      annot.hold("Rotate Speed: %4.2f",pref.spd1); break;
		case '=': pref.spd1*=1.111111; annot.hold("Rotate Speed: %4.2f",pref.spd1); break;

		case '_': pref.spd2*=0.9;      annot.hold("Movement Speed: %4.2f",pref.spd2); break;
		case '+': pref.spd2*=1.111111; annot.hold("Movement Speed: %4.2f",pref.spd2); break;

		case '(': if (maxlight>-1) {
			pref.paren*=0.9;
			annot.hold("Light Rotate Speed: %4.2f",pref.paren);
			} 
			break;
		case ')': if (maxlight>-1) {
			pref.paren*=1.111111;
			annot.hold("Light Rotate Speed: %4.2f",pref.paren);
			} 
			break;

		case '{': pref.brace-=.0025*worldSize; annot.hold("CameraZ: %4.2f",pref.brace); break;
		case '}': pref.brace+=.0025*worldSize; annot.hold("CameraZ: %4.2f",pref.brace); break;

		case '[': pref.bracket*=0.95;     annot.hold("Object Size: %4.2f",pref.bracket);	break;
		case ']': pref.bracket*=1.055555; annot.hold("Object Size: %4.2f",pref.bracket); break;

		case ',':
			pref.fov=(pref.fov>=179)? 179: pref.fov+1;
			annot.hold("FOV: %3.0f Degrees",pref.fov);
			break;
		case '.':
			pref.fov=(pref.fov<= 1)?  1:   pref.fov-1;
			annot.hold("FOV: %3.0f Degrees",pref.fov);
			break;

		case '<': pref.tess=(pref.tess<=mintess)? mintess:pref.tess-1;
			annot.hold("Tesselation: %d",pref.tess);
			break;
		case '>': pref.tess=(pref.tess>=maxtess)? maxtess:pref.tess+1;
			annot.hold("Tesselation: %d",pref.tess);
			break;

		case 'c': case 'C':
			pref.fclock=!pref.fclock;
			if (pref.fclock) annot.hold("Frame/Second Clock On");
			else             annot.hold("Frame/Second Clock Off");
			break;

		case 'd': case 'D':
			pref.fog=!pref.fog;
			if (pref.fog) annot.hold("DepthCue Fog On");
			else          annot.hold("DepthCue Fog Off");
			break;

		case 'f': case 'F':
			pref.fullscreen=!pref.fullscreen;
			if (!pref.fullscreen) glutReshapeWindow(pref.windowx, pref.windowy);
			else {glutFullScreen(); screen.needblank=1;}
			mouse.set_cursor(&pref, dialogs);
			break;

		case 'i': case 'I':
			pref.image=(pref.image>=maximage)?0:pref.image+1;
			doc_image();
			break;

        case 'l':
			{
				static int letterbox=0;
				if (abs(letterbox)!=pref.letterbox) letterbox=pref.letterbox;
				letterbox=(letterbox==6)? -5: letterbox+1;
				pref.letterbox=abs(letterbox);
				annot.hold("Letterbox: %d",pref.letterbox);
				screen.needblank=1;
			}
			break;
		case 'o': case 'O':
			pref.option=(pref.option>=maxoption)?0:pref.option+1;
			doc_option();
			break;

		case 'p': case 'P':
			pref.pause=!pref.pause;
			if (pref.pause) annot.hold("Pause"); 
			   else    annot.hold("Continue"); 
			break;

		case 'r': case 'R':
			init_pref();
			init_vars();
			annot.hold("Reset w/o Prefs");
			screen.needblank=1;
			break;

		case 's': case 'S': pref.lights=!pref.lights;
			if (maxlight>-1) {
				if (pref.lights) annot.hold("SpotLights On");
				   else          annot.hold("SpotLights Off");
			}
			break;

		case 't': case 'T': pref.textures=!pref.textures;
			if (pref.textures) annot.hold("Textures On");
				else            annot.hold("Textures Off");
			break;
		
		case 'v': case 'V': pref.view=(pref.view+1) % 4;
			//pref.view=!(pref.view-1)+1;
			switch(pref.view) {
			case 0:
				annot.hold("Camera 0: Auto-Random");
				break;
			case 1:
				annot.hold("Camera 1: Manual Mouse/Arrow Key Control");
				mouse.moved=1;
				break;
			case 2:
				annot.hold("Camera 2: Hold");
				mouse.moved=1;
				break;
			case 3:
				annot.hold("Camera 3: Auto-Centered");
				mouse.moved=1;
				break;
			}
			mouse.set_cursor(&pref, dialogs);
			break;

      case 'w': case 'W':
         pref.wireframe=(pref.wireframe==2)? 0: pref.wireframe+1;
			set_polymode(&pref);
         break;

		case 'y': keystate|=1; break;
		case '!':
			if (pref.save(titlestr)) annot.hold("Could NOT Save Prefs");
			else                     annot.hold("Saved Prefs");
			break;

		case '@':
			{
				int savedview=pref.view;
				if (pref.load(titlestr))
					annot.hold("Could NOT Load Prefs");
				else {
					annot.hold("Loaded Prefs");
					pref.pause=0;
					pref.view=savedview;
					mouse.set_cursor(&pref,dialogs);
				}
			}
			break;

		case '`':
			if (time.realTime>beginTime) {
				if (!dialogs) {
					screen.needblank=1;
					dialogCurrent->saveView=pref.view;
					if (pref.view!=0) pref.view=2;
					dialogs=1; pref.pause=1;
					dialogCurrent->fadedir=1;
					if (help) help=0;
				} else {
				pref.view=dialogCurrent->saveView;
				dialogs=0; pref.pause=0;
				dialogCurrent->fadedir=0;
				}
				mouse.set_cursor(&pref,dialogs);
			}
			break;

      case '?': case '/':   // title
			help=!help;
			if (!help) screen.needblank=1;
			break;

		case ' ': pref.blank=!pref.blank; break;

		default: break;
	}
	key_this(key.key);
	return;
}

//-----------------------------------------------------------------------------

void specialdown(int inkey, int x, int y){
	key.set_move(inkey);
	//if (!dialogs) {
		switch(inkey) {
			case GLUT_KEY_LEFT: pref.arrowx*=.95;      pref.arrownx-=1; break;
			case GLUT_KEY_RIGHT:pref.arrowx*=1.05263;  pref.arrownx+=1; break;
			case GLUT_KEY_UP:   pref.arrowy*=1.05263;  pref.arrowny-=1; break;
			case GLUT_KEY_DOWN: pref.arrowy*=.95;      pref.arrowny+=1; break;
		}
	//}
	switch(inkey) {
		case GLUT_KEY_PAGE_UP:   pref.page*=1.05263; annot.hold("Page: %4.2f",pref.page); break;
		case GLUT_KEY_PAGE_DOWN: pref.page*=.95;     annot.hold("Page: %4.2f",pref.page); break;

		case GLUT_KEY_INSERT: sound.play("hit.wav"); break;
		case GLUT_KEY_HOME:   pref.home*=1.05263;  annot.hold("Home/End: %4.2f",pref.home);	break;
		case GLUT_KEY_END:    pref.home*=0.95;     annot.hold("Home/End: %4.2f",pref.home);	break;
		case GLUT_KEY_F1:     pref.a1*=0.9;        annot.hold("F1/F2: %4.2f",pref.a1);	break;
		case GLUT_KEY_F2:     pref.a1*=1.111111;   annot.hold("F1/F2: %4.2f",pref.a1);	break;
		case GLUT_KEY_F3:     pref.a2*=0.9;        annot.hold("F3/F4: %4.2f",pref.a2);	break;
		case GLUT_KEY_F4:     pref.a2*=1.111111;   annot.hold("F3/F4: %4.2f",pref.a2);	break;

		case GLUT_KEY_F5:
			pref.b1*=0.95;
			if (pref.b1<NEARZ) pref.b1=NEARZ;
			annot.hold("FogStart: %4.2f",pref.b1);
			pref.fog=1;
			break;
		case GLUT_KEY_F6:
			pref.b1*=1.05263;
			if (pref.b1>FARZ*pref.bracket*4) pref.b1=FARZ*pref.bracket*4;
			if (pref.b1>pref.b2) pref.b1=pref.b2;
			annot.hold("FogStart: %4.2f",pref.b1);
			pref.fog=1;
			break;
		case GLUT_KEY_F7:
			pref.b2*=0.95;
			if (pref.b2<NEARZ) pref.b2=NEARZ;
			if (pref.b2<pref.b1) pref.b2=pref.b1;
			annot.hold("FogEnd: %4.2f",pref.b2);
			pref.fog=1;
			break;
		case GLUT_KEY_F8:
			pref.b2*=1.05263;
			if (pref.b2>FARZ*pref.bracket*4) pref.b2=FARZ*pref.bracket*4;
			annot.hold("FogEnd: %4.2f",pref.b2);
			pref.fog=1;
			break;

		case GLUT_KEY_F9:     pref.c1*=0.9;        annot.hold("F7/F8: %4.2f",pref.c1);	break;
		case GLUT_KEY_F10:    pref.c1*=1.111111;   annot.hold("F7/F8: %4.2f",pref.c1);	break;

		case GLUT_KEY_F11:
			pref.c2*=0.95;
			if (pref.c2<0) pref.c2=0; 
			if (pref.c2<1) pref.blank=0;
			annot.hold("Fade Effect: %4.2f",pref.c2*100);
			break;
		case GLUT_KEY_F12:
			pref.c2*=1.05263;
			if (pref.c2>=1) {
				pref.c2=1;
				pref.blank=1;
			}
			annot.hold("Fade Effect: %4.2f",pref.c2*100);
			break;
		default: break;
	}
	key_this(inkey);
	//if (inkey) dialog_init(dialogCurrent->ID,0); // update dialog
	return;
}

//----------------------------------------------------------------------------------

void specialup(int inkey, int x, int y){
	key.unset_move(inkey);
	return;
}

//----------------------------------------------------------------------------------

void motion(int glutx, int gluty){
	mouse.set(glutx, gluty, &pref, &screen);
	return;
}

//---------------------------------------------------------------------------

void mouseCB(int inbutton, int state, int glutx, int gluty){
	mouse.set(glutx, gluty, &pref, &screen);
	mouse.set_button(inbutton, state);
	if ((mouse.rbutton==1)&&(time.realTime>beginTime))  {

		if (!dialogs) {
			screen.needblank=1;
			dialogCurrent->fadedir=1;
			mouse.lbutton=0;
			mouse.rbutton=0;
			dialogCurrent->saveView=pref.view;
			if (pref.view!=0) pref.view=2;
			//pref.pause=0;
			dialogs=1; 
			if (help) help=0;
		} else {
			pref.view=dialogCurrent->saveView;
			dialogs=0; pref.pause=0;
			dialogCurrent->fadedir=0;
		}
		mouse.set_cursor(&pref,dialogs);
	}
	return;
}

//---------------------------------------------------------------------------

void checkGL(void) {
	int i;
	char tmpc[80];
	GLenum err;
	const GLubyte *errstr;
	static int nerr=0;
   
	if ((err=glGetError())!=GL_NO_ERROR) {
		nerr++;
		errstr=gluErrorString(err);
		for (i=0; i<60; i++)
			if ((tmpc[i]= errstr[i])==0) break;
		check.hold("OpenGL Error: %s",tmpc);
		}
	return;
	}

//---------------------------------------------------------------------------


