//-------------------------------------------------------------------
//	File:		   vector.c
//	Comments:   by George Ziniewicz
//-------------------------------------------------------------------

#include "vector.h"

//-------------------------------------------------------------------

Vector::Vector() {
	return;
};

Vector::~Vector() {};

//-------------------------------------------------------------------

void Vector::make(float inx, float iny, float inz) {
	x=inx;
	y=iny;
	z=inz;
}

//-------------------------------------------------------------------

Vector Vector::cross_prod(Vector v) {
	Vector result;
	
	result.x=(y*v.z)-(z*v.y);
	result.y=(z*v.x)-(x*v.z);
	result.z=(x*v.y)-(y*v.x); 
	return result;
}

//-------------------------------------------------------------------

float Vector::dot_prod(Vector v) {
	return x*v.x+
		    y*v.y+
			 z*v.z;
}

//-------------------------------------------------------------------

float Vector::length(void) {
	return sqrt(x*x+y*y+z*z);
}

//-------------------------------------------------------------------

Vector Vector::normalize(void) {
	float len;
	Vector result;

	len=sqrt(x*x+y*y+z*z);
	result.x=x/len;
	result.y=y/len;
	result.z=z/len;
	return result;
}

//-------------------------------------------------------------------

Vector Vector::add(Vector v) {
	Vector result;
	
	result.x=x+v.x;
	result.y=y+v.y;
	result.z=z+v.z;
	return result;
}

//-------------------------------------------------------------------

Vector Vector::sub(Vector v) {
	Vector result;
	
	result.x=x-v.x;
	result.y=y-v.y;
	result.z=z-v.z;
	return result;
}

//-------------------------------------------------------------------

Vector Vector::mult(float n) {
	Vector result;
	
	result.x=x*n;
	result.y=y*n;
	result.z=z*n;
	return result;
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------
//-------------------------------------------------------------------


Plane::Plane() {
	return;
};

Plane::~Plane() {};

//-------------------------------------------------------------------

void Plane::make(float ina, float inb, float inc, float ind) {
	a=ina;
	b=inb;
	c=inc;
	d=ind;
	normal.x=a;
	normal.y=b;
	normal.z=c;
	return;
}

//-------------------------------------------------------------------

float Plane::distance(Vector v) {
	return a*v.x+
		    b*v.y+
			 c*v.z+d;
}

//-------------------------------------------------------------------
/*
float Plane::calc_d(void) {
	Vector a,n;
	
	n.make(a,b,c);
	m=make();
	return -normal.cross_prod(m);
	return;
}
*/
//-------------------------------------------------------------------





